=== debian/changelog ===
tiledb (1.7.7-3) unstable; urgency=medium

  * debian/patches/series/Reduce_test_surface_in_1.7.7: Remove more tests

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 30 Dec 2021 11:15:26 -0600

tiledb (1.7.7-2) unstable; urgency=medium

  * debian/control: Add Dirk to Uploader per discussion in #1002837

  * test/src/*: Comment out three tests failing in amd64 autobuilder but
    not on standard amd64 machine 

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 30 Dec 2021 07:27:33 -0600

tiledb (1.7.7-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/control: Build-Depends: on catch2, not catch
  * debian/control: Remove clang-format and clang-tidy from Build-Depends
    which are not available on all platforms

 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 29 Dec 2021 17:16:49 -0600

tiledb (1.7.7-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/rules: Turn hdfs off for a more minimal build, also remove sphinx
  * debian/control: Remove Build-Depends: on hdfs
  * debian/control: Set Standards-Version: 2.6.0

  * NMU upload cleared with maintainer and sponsor 	(Closes: #1002837)

 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 29 Dec 2021 09:55:15 -0600

tiledb (1.7.7-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Source-only upload for migration.

 -- Utkarsh Gupta <utkarsh@debian.org>  Thu, 04 Feb 2021 22:16:36 +0530
 

tiledb (1.7.7-1) unstable; urgency=medium

  * Initial release (Closes: #951122).

 -- Adam Cecile <acecile@le-vert.net>  Sun, 12 Apr 2020 16:02:11 +0200
