=== debian/control ===
Source: tiledb
Priority: optional
Maintainer: Adam Cecile <acecile@le-vert.net>
Uploaders: Dirk Eddelbuettel <edd@debian.org>
Build-Depends: debhelper-compat (= 12),
# https://docs.tiledb.com/developer/installation/building-from-source
 cmake (>= 3.3~),
 libssl-dev,
 zlib1g-dev,
 liblz4-dev,
 libbz2-dev,
 libzstd-dev,
 libspdlog-dev,
 libtbb-dev,
 chrpath,
 catch <!nocheck>
Standards-Version: 4.6.0
Section: libs
Homepage: https://tiledb.com/
Vcs-Browser: https://salsa.debian.org/debian/tiledb
Vcs-Git: https://salsa.debian.org/debian/tiledb.git
Rules-Requires-Root: no

Package: libtiledb-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libtiledb1.7 (= ${binary:Version}), ${misc:Depends}
Suggests: libtiledb-doc
Description: Store and access very large multi-dimensional array data (development headers)
 TileDB allows you to store and access very large multi-dimensional array
 data, the data currency of Data Science.
 .
 It is a powerful storage engine that introduces a novel format that can
 effectively store both dense and sparse array data with support for fast
 updates and reads.
 .
 This package contains the development headers.

Package: libtiledb1.7
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libtiledb-doc
Description: Store and access very large multi-dimensional array data (runtime library)
 TileDB allows you to store and access very large multi-dimensional array
 data, the data currency of Data Science.
 .
 It is a powerful storage engine that introduces a novel format that can
 effectively store both dense and sparse array data with support for fast
 updates and reads.
 .
 This package contains the runtime library.

# Need clipp.h
#Package: tiledb
#Section: admin
#Architecture: any
#Multi-Arch: same
#Depends: libtiledb1.7 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
#Suggests: libtiledb-doc
#Description: Store and access very large multi-dimensional array data (cli tool)
# TileDB allows you to store and access very large multi-dimensional array
# data, the data currency of Data Science.
# .
# It is a powerful storage engine that introduces a novel format that can
# effectively store both dense and sparse array data with support for fast
# updates and reads.
# .
# This package contains command line utility.

# Package: libtiledb-doc
# Build-Profiles: <!nodoc>
# Architecture: all
# Section: doc
# Depends: ${sphinxdoc:Depends}, ${misc:Depends}
# Description: Store and access very large multi-dimensional array data (documentation)
#  TileDB allows you to store and access very large multi-dimensional array
#  data, the data currency of Data Science.
#  .
#  It is a powerful storage engine that introduces a novel format that can
#  effectively store both dense and sparse array data with support for fast
#  updates and reads.
#  .
#  This package contains the documentation.
